import { Tag } from '@glimmer/validator';
import { Option } from '@glimmer/interfaces';
import { IterationItemReference, TemplateReferenceEnvironment } from './template';
import { VersionedPathReference } from './reference';
export interface IterationItem<T, U> {
    key: unknown;
    value: T;
    memo: U;
}
export interface AbstractIterator<T, U, V extends IterationItem<T, U>> {
    isEmpty(): boolean;
    next(): Option<V>;
}
export declare type Iterator<T, U> = AbstractIterator<T, U, IterationItem<T, U>>;
export declare type OpaqueIterationItem = IterationItem<unknown, unknown>;
export declare type OpaqueIterator = AbstractIterator<unknown, unknown, OpaqueIterationItem>;
export interface IteratorDelegate {
    isEmpty(): boolean;
    next(): {
        value: unknown;
        memo: unknown;
    } | null;
}
export declare class IterableReference {
    private parentRef;
    private key;
    private env;
    tag: Tag;
    private iterator;
    constructor(parentRef: VersionedPathReference, key: string, env: TemplateReferenceEnvironment);
    value(): boolean;
    isEmpty(): boolean;
    next(): Option<OpaqueIterationItem>;
    private createIterator;
    childRefFor(key: unknown, value: unknown): IterationItemReference<unknown>;
}
//# sourceMappingURL=iterable.d.ts.map